package com.aurellem.capture.audio;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;

import org.tritonus.sampled.file.WaveAudioOutputStream;
import org.tritonus.share.sampled.file.TDataOutputStream;
import org.tritonus.share.sampled.file.TNonSeekableDataOutputStream;

public class WaveFileWriter implements SoundProcessor {

	public File targetFile;
	private WaveAudioOutputStream wao;

	public WaveFileWriter(File targetFile) throws FileNotFoundException{
		wao = new WaveAudioOutputStream(new AudioFormat(44100.0f, 32, 1, true, false),
				AudioSystem.NOT_SPECIFIED, 
				(TDataOutputStream) new TNonSeekableDataOutputStream(
						new FileOutputStream(targetFile)));
	}

	public void cleanup() {
		try {wao.close();}
		catch (IOException e) {e.printStackTrace();}
	}


	public void process(ByteBuffer audioSamples, int numSamples, AudioFormat format) {
		byte[] data = new byte[numSamples];
		audioSamples.get(data, 0, numSamples);
		try {wao.write(data, 0, numSamples);}
		catch (IOException e) {e.printStackTrace();}
	}
}
